class NodoDoppia:

  def __init__(self, value, succ, pred):
    self.value = value
    self.succ = succ
    self.pred = pred


def stampa_lista(testa):
  if testa is None:
    return
  nodo_corrente = testa
  print(str(nodo_corrente.value) + " ", end="")
  nodo_corrente = nodo_corrente.succ
  while nodo_corrente is not testa:
    print(str(nodo_corrente.value) + " ", end="")
    nodo_corrente = nodo_corrente.succ
  print()


def inserisci_testa(testa, x):
  nuovo_nodo = NodoDoppia(x, None, None)
  if testa is not None:
    nuovo_nodo.succ = testa
    nuovo_nodo.pred = testa.pred
    coda = testa.pred
    coda.succ = nuovo_nodo
    testa.pred = nuovo_nodo
  else:
    nuovo_nodo.succ = nuovo_nodo
    nuovo_nodo.pred = nuovo_nodo
  return nuovo_nodo


def array_to_list(array):
  testa = None
  for i in range(len(array)-1, -1, -1):
    testa = inserisci_testa(testa, array[i])
  return testa


def rimuovi(testa, nodo):
  nodo.pred.succ = nodo.succ
  nodo.succ.pred = nodo.pred
  if nodo == testa:
    testa = testa.succ
  if testa.succ == testa:
    return None
  return testa


def cerca(testa, x):
  if testa is None:
    return None
  nodo_corrente = testa
  if nodo_corrente.value == x:
    return nodo_corrente
  nodo_corrente = nodo_corrente.succ
  while nodo_corrente != testa and nodo_corrente.value != x:
    nodo_corrente = nodo_corrente.succ
  return nodo_corrente


# 1 2 3 4 -> 2 3 4 1
def rotate(testa):
  if testa is not None:
    return testa.succ
  else:
    return None

lista = array_to_list([1,2,3,4,5,6,7,8])
