class NodoDoppia:

    def __init__(self, value, succ, pred):
        self.value = value
        self.succ = succ
        self.prec = pred


def stampa_lista(testa):
    nodo_corrente = testa
    while nodo_corrente is not None:
        print(str(nodo_corrente.value) + " ", end="")
        nodo_corrente = nodo_corrente.succ
    print()


def inserisci_in_testa(testa, x):
    nuovo_nodo = NodoDoppia(x, testa, None)
    if testa is not None:
        testa.pred = nuovo_nodo
    return nuovo_nodo


def lista_from_array(array):
    testa = None
    for i in range(len(array) - 1, -1, -1):
        testa = inserisci_in_testa(testa, array[i])
    return testa


def cerca(testa, x):
    nodo_corrente = testa
    while nodo_corrente is not None and nodo_corrente.value != x:
        nodo_corrente = nodo_corrente.succ
    return nodo_corrente


def rimuovi(testa, nodo):
    if nodo.pred is not None:  # il nodo da rimuovere non è la testa
        nodo.pred.succ = nodo.succ
    else:
        testa = nodo.succ
    if nodo.succ is not None:
        nodo.succ.pred = nodo.pred
    return testa
